﻿using System;
using System.IO;
using System.Windows.Forms;
using System.Drawing;
//using ZedGraph;

namespace ThermoVision_JoeC
{
	public static class VARs 
	{
		#region FürSeekAngepasstesUndNutzlosesZeug
		
		const int SeekH=120;
		const int SeekW=160;
		public static int[] Ain = new int[16];
		public static bool lock_ctrl = false;
		//imageprocessing
		public static bool doIP_kanten = false;
		public static bool doIP_prägen = false;
		public static bool doIP_schärfen = false;
		public static float SharpenPWR = 1f;
		public static float KantenTrehs = 1f;
		public static bool DrawMeas=true;
		public static bool VisKantenValid=false;
		public static byte[,] VisKantenArray=new byte[10,10];
		public static bool LockInterpolation=false;
		public static int LockInterpolationState=0;
		//IR Video
		public static string VideoPath = "";
		public static double VideoCount = 0;
		public static int VideoCountMax = 0;
		public static int VideoFirstDataPos = 0;
		public static int VideoFrameSize = 0;
		//File input
		public static FileStream VideoStream;
		public static byte[] FilePuffer;
		public static int FilePufferOffset = 0;
		public static string FilePath = "";
		public static bool FileHasVisual = false;
		public static int FileVisualSize = 0;
		public static int FileInfoOffset = 0;
		public static float FileTempMax = 1;
		public static float FileTempMin = 0;
		public static Point FileMaxPos = new Point(0,0);
		public static Point FileMinPos = new Point(0,0);
		//public static int[,] data_RAW = new int[1,1];
		public static float[,] TempData = new float[SeekW+1,SeekH+1];
		public static ushort[,] TempRaw = new ushort[SeekW+1,SeekH+1];
		public static ushort[,] TempRawBackup = new ushort[SeekW+1,SeekH+1];
		public static ushort TempRawmin = 65535;
		public static ushort TempRawmax = 0;
		public static Point TempDataSize = new Point(SeekW,SeekH);//Mausvars
		//image
//		public static bool Zoom_PosFixed = false;
		public static int Zoom_X = 0;
		public static int Zoom_Y = 0;
		public static int Zoom_quelle = 30;
		public static float BildFaktor = 1.333f;
		public static bool ZoomIRActive = false;
		public static Point mausStart = new Point(10,10);
		public static Point mausIRMeasStart = new Point(10,10);
		public static int mausIRMeasAreaActive=0;
		public static int mausIRMeasAreaState=0;
		public static int mausIRMeasSpotActive=0;
		public static int mausIRMeasSpotState=0;
		public static int mausIRMeasLineActive=0;
		public static int mausIRMeasLineState=0;
		public static Point IRMeasLineOffset=new Point(0,0);
		public static int mausIRMeasAllState=0; //0=nix 1=spot 2=line 3=area
		public static byte[] map_r = new byte[4096];
        public static byte[] map_g = new byte[4096];
      	public static byte[] map_b = new byte[4096];
      	public static bool useBigColorScale = true;
      	public static int PalLen = 4095;
      	public static double IR_Pic_faktor = 0;
      	public static int IR_W_off = 0,IR_H_off = 0;
      	public static int IR_Pic_W = 0,IR_Pic_H = 0;
      	public static int IR_W = 0,IR_H = 0;
		
      	public static double VIS_Pic_faktor = 0;
		public static int VIS_W_off = 0,VIS_H_off = 0;
		public static int VIS_Pic_W = 0,VIS_Pic_H = 0;
		public static int VIS_W = 0,VIS_H = 0;
		
      	public static int maus_X = 10,maus_Y = 10;
      	public static int startmaus_X = 10,startmaus_Y = 10;
      	public static int read_X = 10,read_Y = 10;
      	public static float Temp_Min = 0,Temp_Max = 0,Temp_Center = 0;
      	public static double start_min = 0;
      	public static double start_max = 0;
      	public static double start_iso1_min = 0;
      	public static double start_iso1_max = 0;
      	public static double start_iso2_min = 0;
      	public static double start_iso2_max = 0;
      	public static Bitmap Screen_RadioIR;
		public static Bitmap Farbscala;
		public static volatile int IrOffset_x = 0;
		public static volatile int IrOffset_y = 0;
		public static volatile int IrOffset_h = 0;
		public static volatile int IrOffset_w = 0;
		public static volatile bool Analyse = true;
		public static volatile bool BackPic_Locked = false;
		public static volatile bool Vis_DrawIr = true;
		public static volatile float Vis_Trans = 0.5f;
		public static volatile Bitmap BackPic_IR=new Bitmap(10,10);
		public static Bitmap BackPic_VIS;
		//Bildflächen
		public static string Langpath="";
		public static bool DGW_MeasResult_NoRefresh=false;
		#endregion
		
      	#region RawProcessing
      	public static void Process_RefreshBackup()
        {
//      		long val=0; int cnt=0;
        	TempRawBackup = new ushort[TempDataSize.X,TempDataSize.Y];
        	int X = TempDataSize.X-1;
        	int Y = TempDataSize.Y-1;
        	
			//übertragen
			for (int x = 0; x<=X; x++) {
				for (int y = 0; y<=Y; y++) {
					TempRawBackup[x,y]=TempRaw[x,y];
				}
			}
        }
      	public static void Process_RawMedianRep(int Treshold)
        {
      		double val=0; int cnt=0;
        	ushort[,] Proc = new ushort[TempDataSize.X,TempDataSize.Y];
        	int X = TempDataSize.X-1;
        	int Y = TempDataSize.Y-1;
        	
//        	X = TempDataSize.X;
//        	Y = TempDataSize.Y;
        	//edge W --------------------------------------------
    		for (int y = 1; y < Y; y++) {
                val=0; cnt=0;
                val += TempRaw[0,y-1]; cnt++;  //2
                val += TempRaw[1,y-1]; cnt++;  //3
                val += TempRaw[1,y]; cnt++;  //6
                val += TempRaw[0,y+1]; cnt++;  //8
                val += TempRaw[1,y+1]; cnt++;  //9
				Proc[0,y] = (ushort)(val/(double)cnt);
            }
        	//edge E --------------------------------------------
    		for (int y = 1; y < Y; y++) {
                val=0; cnt=0;
                val += TempRaw[X-1,y-1]; cnt++;  //1
                val += TempRaw[X,y-1]; cnt++;  //2
                val += TempRaw[X-1,y]; cnt++;  //4
                val += TempRaw[X-1,y+1]; cnt++;  //7
                val += TempRaw[X,y+1]; cnt++;  //8
                Proc[X,y] = (ushort)(val/(double)cnt); 
            }
        	//edge N --------------------------------------------
    		for (int x = 1; x < X; x++) {
                val=0; cnt=0;
                val += TempRaw[x-1,0]; cnt++;  //4
                val += TempRaw[x+1,0]; cnt++;  //6
                val += TempRaw[x-1,1]; cnt++;  //7
                val += TempRaw[x,1]; cnt++;  //8
                val += TempRaw[x+1,1]; cnt++;  //9
				Proc[x,0] = (ushort)(val/(double)cnt); 
            }
        	//edge S --------------------------------------------
    		for (int x = 1; x < X; x++) {
                val=0; cnt=0;
                val += TempRaw[x-1,Y-1]; cnt++;  //1
                val += TempRaw[x,Y-1]; cnt++;  //2
                val += TempRaw[x+1,Y-1]; cnt++;  //3
                val += TempRaw[x-1,Y]; cnt++;  //4
                val += TempRaw[x+1,Y]; cnt++;  //6
				Proc[x,Y] = (ushort)(val/(double)cnt); 
            }
        	//übertragen
        	Proc[0,0]=TempRaw[0,0];
        	Proc[0,Y]=TempRaw[0,Y];
        	Proc[X,0]=TempRaw[X,0];
        	Proc[X,Y]=TempRaw[X,Y];
        	//Frame without edges
        	for (int y = 1; y < Y; y++) {
                for (int x = 1; x < X; x++) {
                    //1  2  3
                    //4  5  6
                    //7  8  9
                    val=0; cnt=0;
                    val += TempRaw[x-1,y-1]; cnt++;  //1
                    val += TempRaw[x,y-1]; cnt++;  //2
                    val += TempRaw[x+1,y-1]; cnt++;  //3
                    val += TempRaw[x-1,y]; cnt++;  //4
                    val += TempRaw[x,y]; cnt++;  //5
                    val += TempRaw[x+1,y]; cnt++;  //6
                    val += TempRaw[x-1,y+1]; cnt++;  //7
                    val += TempRaw[x,y+1]; cnt++;  //8
                    val += TempRaw[x+1,y+1]; cnt++;  //9
//                    Proc[x,y] = (ushort)(val/(long)cnt);
					int Wert = (int)(val/(double)cnt);
                	int diff = Wert-Proc[x-1,y];
                	if (diff<0) { diff=0-diff; }
                	int diff2 = Wert-Proc[x,y-1];
                	if (diff2<0) { diff2=0-diff2; }
                	if (diff>diff2) {
	                	if (diff<Treshold) {
                			Proc[x,y] = (ushort)((Proc[x,y-1]*3+Wert)/4);
	                	} else {
	                		Proc[x,y] = (ushort)((TempRaw[x,y]*2+Wert)/3);
	                	}
                	} else {
                		if (diff<Treshold) {
                			Proc[x,y] = (ushort)((Proc[x-1,y]*3+Wert)/4);
	                	} else {
	                		Proc[x,y] = (ushort)((TempRaw[x,y]*2+Wert)/3);
	                	}
                	}
                }
            }
			//übertragen
			TempRawmax=0;TempRawmin=0xffff;
			for (int x = 0; x<=X; x++) {
				for (int y = 0; y<=Y; y++) {
					TempRaw[x,y]=Proc[x,y];
					if (TempRawmax < Proc[x,y]) { TempRawmax = Proc[x,y]; }
					if (TempRawmin > Proc[x,y]) { TempRawmin = Proc[x,y]; }
				}
			}
        }
      	public static void Process_RawMedian()
        {
      		double val=0; int cnt=0;
        	ushort[,] Proc = new ushort[TempDataSize.X,TempDataSize.Y];
        	int X = TempDataSize.X-1;
        	int Y = TempDataSize.Y-1;
        	//Frame without edges
        	for (int y = 1; y < Y; y++) {
                for (int x = 1; x < X; x++) {
                    //1  2  3
                    //4  5  6
                    //7  8  9
                    val=0; cnt=0;
                    val += TempRaw[x-1,y-1]; cnt++;  //1
                    val += TempRaw[x,y-1]; cnt++;  //2
                    val += TempRaw[x+1,y-1]; cnt++;  //3
                    val += TempRaw[x-1,y]; cnt++;  //4
                    val += TempRaw[x,y]; cnt++;  //5
                    val += TempRaw[x+1,y]; cnt++;  //6
                    val += TempRaw[x-1,y+1]; cnt++;  //7
                    val += TempRaw[x,y+1]; cnt++;  //8
                    val += TempRaw[x+1,y+1]; cnt++;  //9
                    Proc[x,y] = (ushort)(val/(double)cnt);
                }
            }
//        	X = TempDataSize.X;
//        	Y = TempDataSize.Y;
        	//edge W --------------------------------------------
    		for (int y = 1; y < Y; y++) {
                val=0; cnt=0;
                val += TempRaw[0,y-1]; cnt++;  //2
                val += TempRaw[1,y-1]; cnt++;  //3
                val += TempRaw[1,y]; cnt++;  //6
                val += TempRaw[0,y+1]; cnt++;  //8
                val += TempRaw[1,y+1]; cnt++;  //9
				Proc[0,y] = (ushort)(val/(double)cnt);
            }
        	//edge E --------------------------------------------
    		for (int y = 1; y < Y; y++) {
                val=0; cnt=0;
                val += TempRaw[X-1,y-1]; cnt++;  //1
                val += TempRaw[X,y-1]; cnt++;  //2
                val += TempRaw[X-1,y]; cnt++;  //4
                val += TempRaw[X-1,y+1]; cnt++;  //7
                val += TempRaw[X,y+1]; cnt++;  //8
                Proc[X,y] = (ushort)(val/(double)cnt); 
            }
        	//edge N --------------------------------------------
    		for (int x = 1; x < X; x++) {
                val=0; cnt=0;
                val += TempRaw[x-1,0]; cnt++;  //4
                val += TempRaw[x+1,0]; cnt++;  //6
                val += TempRaw[x-1,1]; cnt++;  //7
                val += TempRaw[x,1]; cnt++;  //8
                val += TempRaw[x+1,1]; cnt++;  //9
				Proc[x,0] = (ushort)(val/(double)cnt); 
            }
        	//edge S --------------------------------------------
    		for (int x = 1; x < X; x++) {
                val=0; cnt=0;
                val += TempRaw[x-1,Y-1]; cnt++;  //1
                val += TempRaw[x,Y-1]; cnt++;  //2
                val += TempRaw[x+1,Y-1]; cnt++;  //3
                val += TempRaw[x-1,Y]; cnt++;  //4
                val += TempRaw[x+1,Y]; cnt++;  //6
				Proc[x,Y] = (ushort)(val/(double)cnt); 
            }
        	//übertragen
        	Proc[0,0]=TempRaw[0,0];
        	Proc[0,Y]=TempRaw[0,Y];
        	Proc[X,0]=TempRaw[X,0];
        	Proc[X,Y]=TempRaw[X,Y];
        	
			//übertragen
			TempRawmax=0;TempRawmin=0xffff;
			for (int x = 0; x<=X; x++) {
				for (int y = 0; y<=Y; y++) {
					TempRaw[x,y]=Proc[x,y];
					if (TempRawmax < Proc[x,y]) { TempRawmax = Proc[x,y]; }
					if (TempRawmin > Proc[x,y]) { TempRawmin = Proc[x,y]; }
				}
			}
        }
      	public static void Process_RawSharp(float multi)
        {
        	int stop_x=TempDataSize.X-1;
			int stop_y=TempDataSize.Y-1;
			TempRawmin = 65535; TempRawmax = 0;
			ushort[,] Proc = new ushort[TempDataSize.X,TempDataSize.Y];
			for (int x = 1; x<stop_x; x++) {
				for (int y = 1; y<stop_y; y++) {
					float datanew = TempRaw[x,y];
					float val6 = TempRaw[x,y]-TempRaw[x+1,y];
					datanew+=val6*multi;
					float val4 = TempRaw[x,y]-TempRaw[x-1,y];
					datanew+=val4*multi;
					float val2 = TempRaw[x,y]-TempRaw[x,y-1];
					datanew+=val2*multi;
					float val8 = TempRaw[x,y]-TempRaw[x,y+1];
					datanew+=val8*multi;
					float val1 = TempRaw[x,y]-TempRaw[x-1,y-1];
					datanew+=val1*multi;
					float val3 = TempRaw[x,y]-TempRaw[x+1,y-1];
					datanew+=val3*multi;
					float val7 = TempRaw[x,y]-TempRaw[x-1,y+1];
					datanew+=val7*multi;
					float val9 = TempRaw[x,y]-TempRaw[x+1,y+1];
					datanew+=val9*multi;
					if (datanew>0xffff) { datanew= 0xffff; }
					if (datanew<0) { datanew= 0; }
					Proc[x,y]=(ushort)datanew;
				}
			}
			//übertragen
			for (int x = 1; x<stop_x; x++) {
				for (int y = 1; y<stop_y; y++) {
					TempRaw[x,y]=Proc[x,y];
					if (TempRawmax < Proc[x,y]) { TempRawmax = Proc[x,y]; }
					if (TempRawmin > Proc[x,y]) { TempRawmin = Proc[x,y]; }
				}
			}
        }
      	public static short[,] RawRef = new short[1,1];
      	public static bool doGetReference=false;
      	public static void Process_GetRef()
        {
      		RawRef = new short[TempDataSize.X+1,TempDataSize.Y+1];
      		int median = ((TempRawmax-TempRawmin)/2)+TempRawmin;
			for (int y = 0; y < TempDataSize.Y; y++) {
                for (int x = 0; x < TempDataSize.X; x++) {
      				int val = TempRaw[x,y]-median;
      				if (val<short.MinValue) { val=short.MinValue; }
      				if (val>short.MaxValue) { val=short.MaxValue; }
      				RawRef[x,y]=(short)val;
                }
            }
        }
      	public static bool Process_DoRawRef()
        {
      		if (RawRef.Length!=TempRaw.Length) {
      			return false;
      		} else {
      			for (int y = 0; y < TempDataSize.Y; y++) {
	                for (int x = 0; x < TempDataSize.X; x++) {
      					int val = (TempRaw[x,y]-RawRef[x,y]);
	        			if (val<0) { val=0; } if (val>0xffff) { val=0xffff; }
	        			TempRaw[x,y]=(ushort)val;
	                }
	            }
      			return true;
      		}
        }
      	public static string Process_SaveRef(string Filename)
        {
      		try {
      			FileStream FS = new FileStream(Filename,FileMode.Create);
      			FS.WriteByte((byte)(TempDataSize.X>>8&0xff));
	        	FS.WriteByte((byte)(TempDataSize.X&0xff));
	        	FS.WriteByte((byte)(TempDataSize.Y>>8&0xff));
	        	FS.WriteByte((byte)(TempDataSize.Y&0xff));
      			for (int y = 0; y < TempDataSize.Y; y++) {
	                for (int x = 0; x < TempDataSize.X; x++) {
      					int val = RawRef[x,y]+short.MaxValue;
      					FS.WriteByte((byte)(val>>8&0xff));
	        			FS.WriteByte((byte)(val&0xff));
	                }
	            }
	        	FS.Close();
	        	return "OK";
      		} catch (Exception err) {
      			return err.Message.ToString()+"!";
      		}
        }
      	public static string Process_LoadRef(string Filename)
        {
      		if (!File.Exists(Filename)) {
  				return "File not Exist!";
  			}
      		try {
      			FileStream FS = new FileStream(Filename,FileMode.Open);
      			FS.Close();
      		} catch (Exception) {
      			return "File could not open!";
      		}
      		try {
      			
      			FileStream FS = new FileStream(Filename,FileMode.Open);
      			byte B0 = (byte)FS.ReadByte();
      			byte B1 = (byte)FS.ReadByte();
      			int X = B0<<8|B1;
      			B0 = (byte)FS.ReadByte();
      			B1 = (byte)FS.ReadByte();
      			int Y = B0<<8|B1;
      			RawRef = new short[X+1,Y+1];
      			for (int y = 0; y < Y; y++) {
	                for (int x = 0; x < X; x++) {
      					int B = FS.ReadByte();
      					if (B==-1) {
      						FS.Close();
      						return "Zu wenig daten in der Datei!";
      					} else { B0 = (byte)B; }
      					B = FS.ReadByte();
      					if (B==-1) {
      						FS.Close();
      						return "Zu wenig daten in der Datei!";
      					} else { B1 = (byte)B; }
      					int val = B0<<8|B1;
      					RawRef[x,y]=(short)(val-short.MaxValue);
	                }
	            }
      			FS.Close();
	        	return "OK";
      		} catch (Exception err) {
      			return err.Message.ToString()+"!";
      		}
        }
      	public static ushort[,] RawAVRRef = new ushort[1,1];
      	public static void Process_RawAVR(int multi)
        {
        	int stop_x=TempDataSize.X-1;
			int stop_y=TempDataSize.X-1;
			try {
				long ges = (long)multi;
				long last = ges-1L;
				for (int y = 0; y < TempDataSize.Y; y++) {
	                for (int x = 0; x < TempDataSize.X; x++) {
		        		long val = (long)RawAVRRef[x,y]*last;
	            		val+=TempRaw[x,y];
	            		RawAVRRef[x,y]=(ushort)(val/ges);
	            		TempRaw[x,y]=RawAVRRef[x,y];
	                }
	            }
			} catch (Exception) {
				RawAVRRef = new ushort[TempDataSize.X+1,TempDataSize.Y+1];
				for (int y = 0; y < TempDataSize.Y; y++) {
	                for (int x = 0; x < TempDataSize.X; x++) {
	            		RawAVRRef[x,y]=TempRaw[x,y];
	                }
	            }
			}
        }
      	public static double[,] ConvKernel = new double[,]{{1,2,1},{2,4,2},{1,2,1}};
      	public static void Process_Convolution()
      	{
      		Process_Convolution(ConvKernel);
      	}
      	public static void Process_Gausian(double Sigma)
      	{
      		double L = 1;
      		double M = Sigma;
      		double H = Sigma+Sigma;
      		double[,] GausKernel = new double[,]{{L,M,L},{M,H,M},{L,M,L}};
      		Process_Convolution(GausKernel);
      	}
      	public static void Process_Convolution(double[,] Kernel)
      	{
      		ushort[,] Proc = Process_ConvolutionExtern(Kernel);
			TempRawmax=0;TempRawmin=0xffff;
			for (int x = 0; x<TempDataSize.X; x++) {
				for (int y = 0; y<TempDataSize.Y; y++) {
					TempRaw[x,y]=Proc[x,y];
					if (TempRawmax < Proc[x,y]) { TempRawmax = Proc[x,y]; }
					if (TempRawmin > Proc[x,y]) { TempRawmin = Proc[x,y]; }
				}
			}
      	}
      	public static ushort[,] Process_ConvolutionExtern(double[,] Kernel)
      	{
      		double val=0;
        	ushort[,] Proc = new ushort[TempDataSize.X,TempDataSize.Y];
        	int X = TempDataSize.X-1;
        	int Y = TempDataSize.Y-1;
        	double ges = Kernel[0,0]+Kernel[1,0]+Kernel[2,0]+
        				 Kernel[0,1]+Kernel[1,1]+Kernel[2,1]+
        				 Kernel[0,2]+Kernel[1,2]+Kernel[2,2];
        	if (ges==0) { ges=0.0001; }
        	//Frame without edges
        	for (int y = 1; y < Y; y++) {
                for (int x = 1; x < X; x++) {
                    //1  2  3
                    //4  5  6
                    //7  8  9
                    val=0;
                    val += VARs.TempRaw[x-1,y-1]*Kernel[0,0];  //1
                    val += VARs.TempRaw[x,y-1]*Kernel[1,0];  //2
                    val += VARs.TempRaw[x+1,y-1]*Kernel[2,0];  //3
                    val += VARs.TempRaw[x-1,y]*Kernel[0,1];  //4
                    val += VARs.TempRaw[x,y]*Kernel[1,1];  //5
                    val += VARs.TempRaw[x+1,y]*Kernel[2,1];  //6
                    val += VARs.TempRaw[x-1,y+1]*Kernel[0,2];  //7
                    val += VARs.TempRaw[x,y+1]*Kernel[1,2];  //8
                    val += VARs.TempRaw[x+1,y+1]*Kernel[2,2];  //9
                    
                    val=val/ges;
                    if (val<0) { val=0; } if (val>65535) { val=65535; }
                    Proc[x,y] = (ushort)(val);
                }
            }
        	//edge W --------------------------------------------
        	//-  2  3
            //-  5  6
            //-  8  9
        	ges = Kernel[1,0]+Kernel[2,0]+Kernel[1,1]+Kernel[2,1]+Kernel[1,2]+Kernel[2,2];
        	if (ges==0) { ges=0.0001; }
    		for (int y = 1; y < Y; y++) {
                val=0;
                val += TempRaw[0,y-1]*Kernel[1,0];  //2
                val += TempRaw[1,y-1]*Kernel[2,0];  //3
                val += TempRaw[0,y]*Kernel[1,1];  //5
                val += TempRaw[1,y]*Kernel[2,1];  //6
                val += TempRaw[0,y+1]*Kernel[1,2];  //8
                val += TempRaw[1,y+1]*Kernel[2,2];  //9
                val=val/ges;
                if (val<0) { val=0; } if (val>65535) { val=65535; }
                Proc[0,y] = (ushort)(val);
            }
        	//edge E --------------------------------------------
        	//1  2  -
            //4  5  -
            //7  8  -
            ges = Kernel[0,0]+Kernel[1,0]+Kernel[0,1]+Kernel[1,1]+Kernel[0,2]+Kernel[1,2];
            if (ges==0) { ges=0.0001; }
    		for (int y = 1; y < Y; y++) {
                val=0;
                val += TempRaw[X-1,y-1]*Kernel[0,0];  //1
                val += TempRaw[X,y-1]*Kernel[1,0];  //2
                val += TempRaw[X-1,y]*Kernel[0,1];  //4
                val += TempRaw[X,y]*Kernel[1,1];  //5
                val += TempRaw[X-1,y+1]*Kernel[0,2];  //7
                val += TempRaw[X,y+1]*Kernel[1,2];  //8
                val=val/ges;
                if (val<0) { val=0; } if (val>65535) { val=65535; }
                Proc[X,y] = (ushort)(val);
            }
        	//edge N --------------------------------------------
        	//-  -  -
            //4  5  6
            //7  8  9
            ges = Kernel[0,1]+Kernel[1,1]+Kernel[2,1]+Kernel[0,2]+Kernel[1,2]+Kernel[2,2];
            if (ges==0) { ges=0.0001; }
    		for (int x = 1; x < X; x++) {
                val=0;
                val += TempRaw[x,0]*Kernel[1,1];  //5
                val += TempRaw[x-1,0]*Kernel[0,1];  //4
                val += TempRaw[x+1,0]*Kernel[2,1];  //6
                val += TempRaw[x-1,1]*Kernel[0,2];  //7
                val += TempRaw[x,1]*Kernel[1,2];  //8
                val += TempRaw[x+1,1]*Kernel[2,2];  //9
				val=val/ges;
                if (val<0) { val=0; } if (val>65535) { val=65535; }
                Proc[x,0] = (ushort)(val);
            }
        	//edge S --------------------------------------------
        	//1  2  3
            //4  5  6
            //-  -  -
            ges = Kernel[0,0]+Kernel[1,0]+Kernel[2,0]+Kernel[0,1]+Kernel[1,1]+Kernel[2,1];
            if (ges==0) { ges=0.0001; }
    		for (int x = 1; x < X; x++) {
                val=0;
                val += TempRaw[x-1,Y-1]*Kernel[0,0];  //1
                val += TempRaw[x,Y-1]*Kernel[1,0];  //2
                val += TempRaw[x+1,Y-1]*Kernel[2,0];  //3
                val += TempRaw[x-1,Y]*Kernel[0,1];  //4
                val += TempRaw[x,Y]*Kernel[1,1];  //5
                val += TempRaw[x+1,Y]*Kernel[2,1];  //6
                val=val/ges;
                if (val<0) { val=0; } if (val>65535) { val=65535; }
                Proc[x,Y] = (ushort)(val);
            }
        	//übertragen
        	val=(TempRaw[0,0]+Proc[0,1]+Proc[1,0])/3;
        	if (val<0) { val=0; } if (val>65535) { val=65535; }
            Proc[0,0] = (ushort)(val);
            val=(TempRaw[0,Y]+Proc[0,Y-1]+Proc[1,Y])/3;
        	if (val<0) { val=0; } if (val>65535) { val=65535; }
            Proc[0,Y] = (ushort)(val);
            val=(TempRaw[X,0]+Proc[X,1]+Proc[X-1,0])/3;
        	if (val<0) { val=0; } if (val>65535) { val=65535; }
            Proc[X,0] = (ushort)(val);
            val=(TempRaw[X,Y]+Proc[X,Y-1]+Proc[X-1,Y])/3;
        	if (val<0) { val=0; } if (val>65535) { val=65535; }
            Proc[X,Y] = (ushort)(val);
        	
			//übertragen
			return Proc;
      	}
      	#endregion
	}
}